#include "StdAfx.h"
#include <windows.h>
#include <GL/glu.h>
#include "OpenGL.h"

#pragma comment (lib, "OpenGL32.lib")
#pragma comment (lib, "GLU32.lib")
#pragma comment (lib, "user32.lib") //getDCȂǂ̂
#pragma comment(lib, "gdi32.lib")   //SetPixelFormatȂǂ̂

#include <math.h>

#ifndef M_PI
#define M_PI 3.141592653589793
#endif

#include "GLDrawingtool3D.h"

COpenGL::COpenGL(void)
{
	tick=0;
	mousestatus=0;
	leye=700.0;
	dip=0.65;
	rot=0.5; //dip,rot[rad]
}


COpenGL::~COpenGL(void)
{
}

bool COpenGL::attach_GL(System::Windows::Forms::PictureBox^ pbox)
{
	if (!(hWnd=(HWND)(pbox->Handle).ToInt32())) {
		//0 (NULL) ȂsĂяo
		MessageBox(NULL, (LPCTSTR)("COpenGL::attach_GL  called with 0 (NULL"), NULL, MB_OK);
		return false;
	}

	if (!(hdc=GetDC(hWnd))) { 
		//GetDC(hWnd)ƃfoCXReLXg̃nhԂCs 0 (NULL) ԂB
		MessageBox(NULL, (LPCTSTR)("COpenGL::attach_GL GetDC(hWnd)"), NULL, MB_OK);
		return false;
	}

	wglMakeCurrent(NULL, NULL); //VS2010p̏dvȂ܂Ȃ@̈ʒuɒuȂwglCreateContext(hdc)s

	if (setPixelFormat(hdc)!=1)
		return false;

	if (!(hglrc = wglCreateContext(hdc))) {
		MessageBox(NULL, (LPCTSTR)("COpenGL::attach_GL wglCreateContext(hdc)"), NULL, MB_OK);
		return false;
	}

	if(!wglMakeCurrent(hdc, hglrc)) {
		MessageBox(NULL, (LPCTSTR)("COpenGL::attach_GL wglMakeCurrent(hdc, hglrc)"), NULL, MB_OK);
		return false;
	}

	setPerspective(pbox);

	initializeScene();

	return true;
}

void COpenGL::resizeScene( System::Windows::Forms::PictureBox^ pbox )
{
	setPerspective(pbox);
}

void COpenGL::OnLButtonDown(Point point)
{
	if(mousestatus==0) {
		mousestatus=1;
		posDown=point;
	}
}

void COpenGL::OnLButtonUp(Point point)
{
	if(mousestatus==2) {
		mousestatus=3;
		posUp=point;
		paintWindow();
	}
}

void COpenGL::OnMouseMove(Point point)
{
	if (0<mousestatus) {
		mousestatus=2;
		posDrag=point;
		paintWindow();
	}
}

void COpenGL::setPerspective( System::Windows::Forms::PictureBox^ pbox )
{
	int width=pbox->Width;
	int height=pbox->Height;
	glViewport(0,0,width,height);
	glEnable(GL_DEPTH_TEST);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	const int angle=40;
	const int frontPlanePosZ=100;
	const int rearPlanePosZ=1300;
	gluPerspective(angle, (float)width/(float)height, frontPlanePosZ, rearPlanePosZ);
}

void COpenGL::detach_GL()
{
	wglMakeCurrent(NULL, NULL) ;
	if (hglrc) wglDeleteContext(hglrc);
	if (hdc) ReleaseDC(hWnd, hdc);
}

int COpenGL::setPixelFormat(HDC hdc)
{
	PIXELFORMATDESCRIPTOR pfd = { 
	    sizeof(PIXELFORMATDESCRIPTOR),    // size of this pfd 
	    1,                                // version number 
	    PFD_DRAW_TO_WINDOW |              // support window 
	    PFD_SUPPORT_OPENGL |              // support OpenGL 
	    PFD_DOUBLEBUFFER,                 // double buffered 
	    PFD_TYPE_RGBA,                    // RGBA type 
	    24,                               // 24-bit color depth 
	    0, 0, 0, 0, 0, 0,                 // color bits ignored 
	    0,                                // no alpha buffer 
	    0,                                // shift bit ignored 
	    0,                                // no accumulation buffer 
	    0, 0, 0, 0,                       // accum bits ignored 
	    32,                               // 32-bit z-buffer     
	    0,                                // no stencil buffer 
	    0,                                // no auxiliary buffer 
	    PFD_MAIN_PLANE,                   // main layer 
	    0,                                // reserved 
	    0, 0, 0                           // layer masks ignored 
	}; 
	int  iPixelFormat; 
 
	// get the device context's best, available pixel format match 
	if((iPixelFormat = ChoosePixelFormat(hdc, &pfd)) == 0) {
		MessageBox(NULL, (LPCTSTR)("ChoosePixelFormat Failed"), NULL, MB_OK);
		//MessageBox((LPCTSTR)("ChoosePixelFormat Failed"));
		return 0;
	}
	 
	// make that match the device context's current pixel format 
	if(SetPixelFormat(hdc, iPixelFormat, &pfd) == FALSE) {
		MessageBox(NULL, (LPCTSTR)("SetPixelFormat Failed"), NULL, MB_OK);
		//MessageBox((LPCTSTR)("SetPixelFormat Failed"));
		return 0;
	}

	return 1;
}

void COpenGL::initializeScene(void)
{
}

// COpenGL bZ[W nh@FormĂ΂
void COpenGL::increaseTick()
{
	tick++;
}

GLfloat light0pos[] = { 500.0, 1500.0, 500.0, 0.0 }; // x,y,z,d
GLfloat White[] = { 1.0, 1.0, 1.0, 1.0 }; // R,G,B,A
GLfloat Black[] = { 0.0, 0.0, 0.0, 1.0 }; // R,G,B,A
GLfloat Brown[] = { 0.3f, 0.25f, 0.0, 1.0 }; // R,G,B,A
GLfloat Cyan[] = { 0.0, 0.95f, 0.9f, 1.0 }; // R,G,B,A
GLfloat Gray[] = { 0.25f, 0.25f, 0.25f, 1.0 }; // R,G,B,A
GLfloat Red[] = { 1.0, 0.0, 0.0, 1.0 }; // R,G,B,A
GLfloat Shine[] = { 100.0}; //0.0(large highlight) ... 128.0(small highlight)

void COpenGL::paintWindow(void) 
{
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glEnable(GL_NORMALIZE); // normarize normal vectors

	double ddip=0,drot=0,dip1,rot1;
	double ly,lxz,lx,lz;
	if (mousestatus==2) {
		ddip=(posDrag.Y-posDown.Y)*0.01;
		drot=-(posDrag.X-posDown.X)*0.01;
	} else if (mousestatus==3) {
		ddip=(posUp.Y-posDown.Y)*0.01;
		drot=-(posUp.X-posDown.X)*0.01;
		dip+=ddip;
		rot+=drot;
		if (0.4999*M_PI<dip) dip=0.4999*M_PI;
		if (dip<-0.4999*M_PI) dip=-0.4999*M_PI;
		mousestatus=0;
		ddip=0,drot=0;
	}
	dip1=dip+ddip;
	rot1=rot+drot;
	if (0.4999*M_PI<dip1) dip1=0.4999*M_PI;
	if (dip1<-0.4999*M_PI) dip1=-0.4999*M_PI;
	ly=leye*sin(dip1); lxz=leye*cos(dip1);
	lx=lxz*sin(rot1); lz=lxz*cos(rot1);
	gluLookAt(lx,ly,lz, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0, GL_AMBIENT, White);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, White);
	glLightfv(GL_LIGHT0, GL_SPECULAR, White);
	glLightfv(GL_LIGHT0, GL_POSITION, light0pos); //definition of light position must be here
	glClearColor(0.1f,0,0.5f,0);
	glClear(GL_COLOR_BUFFER_BIT);
	glClear(GL_DEPTH_BUFFER_BIT); // depth check
	glMaterialfv(GL_FRONT, GL_AMBIENT, White); // Attribute of the Axes
	drawAxes();

 	renderScene();//render here
	SwapBuffers(hdc);
}

polyhedron_t cube={
	8, //number of vertices of the cube
	{
		{50,50,50},{50,50,-50},{-50,50,-50},{-50,50,50},
		{50,-50,50},{50,-50,-50},{-50,-50,-50},{-50,-50,50}
	}, // coordinates of the vertices of the cube
	6, // number of faces of the cube
	{
		{4,{0,1,2,3},{0,1,0}}, {4,{0,4,5,1},{1,0,0}},
		{4,{1,5,6,2},{0,0,-1}}, {4,{2,6,7,3},{-1,0,0}},
		{4,{3,7,4,0},{0,0,1}}, {4,{7,6,5,4},{0,-1,0}}
	} // every face has four vertices and showing vertex numbers
};

void COpenGL::renderScene(void)
{
	glShadeModel(GL_SMOOTH);

	float k1=tick/200.f;
	glRotatef(k1*360.0f, 0.0, 1.0, 0.0); // Matrix A
	glTranslatef(200.0f, 0.0, 0.0);      // Matrix B
	glRotatef(k1*360.0f, 0.0, 0.0, 1.0); // Matrix C
	// Then Transformation Matrix for the cube is A*B*C

	glMaterialfv(GL_FRONT, GL_AMBIENT, Gray); //Attribute of the cube
	glMaterialfv(GL_FRONT, GL_DIFFUSE, Cyan);
	glMaterialfv(GL_FRONT, GL_SPECULAR, White);
	glMaterialfv(GL_FRONT, GL_SHININESS, Shine);
	putFlatPolyhedron(cube);

}
